<template>
  <div>
    <div data-cypress="config">
      Configuration du Nonogramme
      <br/>

      <label>Nombre de colonnes</label>
      <input v-model.number="numberCellsUser" type="number" />

      <label>Nombre de lignes</label>
      <input v-model.number="numberRowsUser" type="number" />

      <button @click="transmitSizeToEditor">
        Créer le nonogramme
      </button>
    </div>

    <picross-editor
      :number-rows="numberRowsEditor"
      :number-cells="numberCellsEditor"
      @update-picross-data="updatePicrossData"
    />

    <div>
      <label>Titre</label>
      <input v-model="title" type="text" />
      <br/>

      <button @click="exportPicross">
        Exporter le nonogramme
      </button>
      <pre
        style="border: 1px solid gray; height: 10rem;overflow: auto;"
      >{{ picrossExported }}</pre>
    </div>

  </div>
</template>

<script>
// @ is an alias to /src
import PicrossEditor from '@/components/PicrossEditor'

export default {
  name: 'Editor',
  components: {
    'picross-editor': PicrossEditor
  },
  data () {
    return {
      title: '',
      numberRowsUser: 7,
      numberCellsUser: 7,
      numberRowsEditor: null,
      numberCellsEditor: null,
      cellsValues: null,
      currentPicrossEditorData: {},
      picrossExported: null
    }
  },
  methods: {
    exportPicross () {
      this.picrossExported = {
        title: this.title,
        ...this.currentPicrossEditorData
      }
    },
    updatePicrossData (newPicrossData) {
      this.currentPicrossEditorData = newPicrossData
    },
    transmitSizeToEditor () {
      this.numberRowsEditor = this.numberRowsUser
      this.numberCellsEditor = this.numberCellsUser
    }
  }
}
</script>
